<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\ECharts\Technik\PocetKontrolPodlaHodnotenia;

use Illuminate\Contracts\Support\Arrayable;
use Illuminate\Contracts\Support\Jsonable;
use JsonSerializable;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\HodnotenieEmisnejKontrolyEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaHodnotenia;
use Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\ECharts\EChartSourceItemContract;

/**
 * Class PocetKontrolPodlaStavuEChartSourceItem
 *
 * @package Seka\Portal\Modul\Statistiky\Repositories\Eloquent\Transformers\Summary\ECharts\Technik\PocetKontrolPodlaHodnotenia
 */
final class PocetKontrolPodlaHodnoteniaEChartSourceItem implements EChartSourceItemContract, Arrayable, Jsonable, JsonSerializable
{
    /**
     * @var array
     */
    private array $poctyKontrolPodlaHodnotenia = [];

    /**
     * @var string
     */
    private string $technik;

    /**
     * @var int
     */
    private int $spolu = 0;

    /**
     * @param string $technik
     */
    public function __construct(string $technik)
    {
        $this->technik = $technik;

        foreach (HodnotenieEmisnejKontrolyEnum::toValues() as $k) {
            $this->poctyKontrolPodlaHodnotenia[$k] = 0;
        }
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaHodnotenia $pocetKontrolPodlaHodnotenia
     *
     * @return $this
     */
    public function add(PocetKontrolPodlaHodnotenia $pocetKontrolPodlaHodnotenia): self
    {
        $this->poctyKontrolPodlaHodnotenia[$pocetKontrolPodlaHodnotenia->hodnotenie()->value] += $pocetKontrolPodlaHodnotenia->pocet();
        $this->spolu += $pocetKontrolPodlaHodnotenia->pocet();

        return $this;
    }

    /**
     * @param int $options
     *
     * @return string
     */
    public function toJson($options = 0): string
    {
        return json_encode($this->toArray(), $options);
    }

    /**
     * @return array
     */
    public function toArray(): array
    {
        return array_merge([
            'label' => $this->technik,
            'spolu' => $this->spolu,
        ], $this->poctyKontrolPodlaHodnotenia);
    }

    /**
     * @return array
     */
    public function jsonSerialize(): array
    {
        return $this->toArray();
    }
}
